var gulp = require('gulp');
var sass = require('gulp-sass');
var sassGlob = require('gulp-sass-glob');
var autoprefixer = require('gulp-autoprefixer');
var sourcemaps = require('gulp-sourcemaps');
var parentThemeFolder = '../../contrib/holy';
var replace = require('gulp-replace');
var mergeFolder = 'sass_merge/';

// Copy parent theme sass files (Holy).
gulp.task('moveParent', function () {
  console.log('Copy parent theme Sass files to merge folder.');
  return gulp.src(parentThemeFolder + '/sass/**/*.scss')
    .pipe(replace('../', '../' + parentThemeFolder + '/'))
    .pipe(gulp.dest(mergeFolder));
});

// Copy child theme sass files.
gulp.task('moveCurrent',  function () {
  console.log('Copy current theme Sass files to merge folder.');
  return gulp.src('sass/**/*.scss')
    .pipe(gulp.dest(mergeFolder));
});

// Sass processing of the merge folder.
gulp.task('sass', gulp.series('moveCurrent', function () {
  console.log('Sass processing.');
  return gulp.src(mergeFolder + '*.scss')
    .pipe(sassGlob())
    .pipe(sourcemaps.init())
    .pipe(sass({
      compress: FALSE
    }))
    .pipe(autoprefixer({
      cascade: FALSE
    }))
    .pipe(sourcemaps.write('./'))
    .pipe(gulp.dest('./css'));

}));

// Merge both sass files and process it.
gulp.task('merge', gulp.series('moveParent', 'sass'));

gulp.task('watch', gulp.series('merge', function () {
  console.log('Start watching file');
  return gulp.watch('./sass/**/*.scss', { alwaysStat: TRUE } , gulp.series('sass'));
}));

gulp.task('default', gulp.series('merge'));
